---
description: 'Something Unique. Hilbish is the new interactive shell for Lua fans. Extensible, scriptable, configurable: All in Lua.'
---

[//]: <>

<!-- hugo (prob goldmark) is funny; the html wont work if its the first thing -->
<div class="text-center">
	<h1 class="fw-light">Something Unique.</h1>
		<p>
			<strong>🌺 Hilbish</strong> is the new Moon-powered interactive shell for Lua fans!<br>
			Extensible, scriptable, configurable: All in Lua. ✨
		</p>
	<a href="install" class="btn btn-primary">Install</a>
	<a href="https://github.com/Rosettea/Hilbish" class="btn btn-secondary" target="_blank">GitHub</a>
</div>

<hr>

<div class="row row-cols-1 row-cols-md-2 g-4">
	<div class="col">
		<div class="card">
			<div class="card-body">
				<h5 class="card-title">Simple and Easy Scripting</h5>
				<p class="card-text">Hilbish is configured and scripted in the
				Lua programming language. This removes all the old, ugly things
				about Shell script and introduces everything good about Lua,
				including other languages (Fennel, Lua derivatives).</p>
			</div>
		</div>
	</div>
	<div class="col">
		<div class="card">
			<div class="card-body">
				<h5 class="card-title">History and Completion Menus</h5>
				<p class="card-text">Hilbish provides the user with proper menus
				for completions and history usage. Want to see your previous commands?
				Hit Ctrl-R.</p>
			</div>
		</div>
	</div>
	<div class="col">
		<div class="card">
			<div class="card-body">
				<h5 class="card-title">Tons of Features, and More to Come</h5>
				<p class="card-text">Hilbish offers a bunch of features to make your
				interactive shell experience rich. Things like syntax highlighting
				and hinting available via the Lua API.</p>
			</div>
		</div>
	</div>
	<div class="col">
		<div class="card">
			<div class="card-body">
				<h5 class="card-title">Customizable and Extensible via an accessible Lua API</h5>
				<p class="card-text">Want to change the language used for interactive input?
				Or maybe monitor and notify for the output of background jobs?
				Have a real-time updating prompt? All this can be done in Hilbish!</p>
			</div>
		</div>
	</div>
</div>

<hr>

<h1 class="fw-light">Why not just Lua?</h1>
<p>
	Hilbish is your interactive shell as well as a just a Lua interpreter
	and enhanced REPL.<br>
</p>
<ul class="list-group">
	<li class="list-group-item"><i class="fa-solid fa-battery-full"></i> Batteries included Lua runtime that's also your user shell!</li>
	<li class="list-group-item"><i class="fa-solid fa-network-wired"></i> Provides cross-platform and OS agnostic APIs to ensure your Lua code works everywhere Hilbish does, as expected.</li>
</ul>

<hr>

<h1 class="fw-light">Try It Today!</h1>
<p>
	Hilbish is known to run on the 3 major platforms (Windows, MacOS, Linux)
	but likely builds on other Unixes! Windows doesn't work as well as it should,
	so if you're a Windows user,
	<a href="https://github.com/Rosettea/Hilbish/discussions/165">say something</a>!
	<ul class="list-group">
		<li class="list-group-item"><i class="fa-solid fa-cloud-arrow-down"></i> <a href="/Hilbish/install" style="text-decoration: none;"><strong>Download</strong></a> the binary</li>
		<li class="list-group-item"><i class="fa-solid fa-screwdriver-wrench"></i> <a href="https://github.com/Rosettea/Hilbish#manual-build" style="text-decoration: none;"><strong>Build</strong></a> from source</li>
	</ul>
</p>
